; MOWmon - Message-Only Windows monitor
; http://www.geocities.com/xmemor/2lz/mowmon.zip
; http://www.geocities.com/xmemor/2lz/tinyasm.html

.386
.model	flat,stdcall
option	casemap:none

include			\masm32\include\windows.inc
include			\masm32\include\user32.inc
include			\masm32\include\kernel32.inc
include			\masm32\include\shell32.inc
include			\masm32\include\shlwapi.inc
includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\shell32.lib
includelib	\masm32\lib\shlwapi.lib

;EnChProc		proto :DWORD,:DWORD,:DWORD
;EnWinProc	proto :DWORD,:DWORD

.data

filename		db "MOWmon.txt",0
about				db "by kero <geocities.com/xmemor> v.2005-03-01",0

caption			db "SET MONOSPACED FONT: Courier, FixedSys,..",13,10,13,10
						db "%7shWnd%5sStatus  Width  Height   Left    Top   ThreadID   ProcessID  Exec.file%s%d%sText%s%d%sClass",13,10,13,10,0

format			db "%4lu   %8.8lx   %s  %6d  %6d  %6d %6d   %8.8lx   %8.8lx   ",0
format0			db "%s%s-%d%s   %s-%d%s   %s%s",13,10,0
p_					db "%",0
s_					db "s",0
;tout				db "<<WTS_timeout_error>>",0

.data?

hwin				dd ?
hMon				dd ?
processid		dd ?
threadid		dd ?
hSnapshot		dd ?
pe32				PROCESSENTRY32 <?>
rt					RECT <?>
lft					dd ?
tp					dd ?
wdth				dd ?
hght				dd ?
count				dd ?
fnamelen		dd ?
fnamelen2		dd ?
namelen			dd ?
namelen2		dd ?
status			dd ?
bigbuf			db 65535 dup(?)
bigbuf2			db 65535 dup(?)
buf					db 1024 dup(?)
frmt				db 512 dup(?)
winclass		db MAX_PATH+1 dup(?)
winname			db MAX_PATH+1 dup(?)
windowfile	db MAX_PATH+1 dup(?)

.code

;###########################################################################################

EnChProc proc hwnd:HWND,param:DWORD
		invoke SendMessageTimeout,hwnd,WM_GETTEXT,MAX_PATH,addr winname,SMTO_ABORTIFHUNG,20,0
;		test eax,eax
;		jnz @f
;		invoke lstrcpy,addr winname,addr tout
;;		invoke	GetWindowText,hwnd,addr winname,MAX_PATH
;@@:
		invoke lstrcmp,addr winname,addr filename
		test	eax,eax
		jz @f
		ret
@@:
		mov	eax,hwnd
		mov	hMon,eax
		xor	eax,eax
	 	ret
EnChProc endp

;###########################################################################################

EnWinProc proc hwnd:HWND,param:DWORD
		mov	byte ptr status,'H'
		invoke IsWindowVisible,hwnd
		test eax,eax
		jz @f
		mov	byte ptr status,'V'
@@:
		mov byte ptr status+1,'D'
		invoke IsWindowEnabled,hwnd
		test eax,eax
		jz @f
		mov	byte ptr status+1,'E'
@@:
;		mov	byte ptr status+2,' '
;		invoke IsIconic,hwnd
;		test eax,eax
;		jz @skp
;		mov	byte ptr status+2,'m'
;		jmp @f
;@skp:
;		invoke IsZoomed,hwnd
;		test eax,eax
;		jz @f
;		mov	byte ptr status+2,'M'
;@@:
		invoke GetWindowRect,hwnd,addr rt
		mov	eax,rt.left
		mov	lft,eax
		mov	eax,rt.top
		mov	tp,eax
		mov	eax,rt.right
		mov	wdth,eax
		mov	eax,rt.bottom
		mov	hght,eax
		mov	eax,lft
		sub	wdth,eax		
		mov	eax,tp
		sub	hght,eax
		invoke GetWindowThreadProcessId,hwnd,addr processid
		mov	threadid,eax
		invoke CreateToolhelp32Snapshot,TH32CS_SNAPPROCESS,processid
		mov	hSnapshot,eax
		mov	pe32.dwSize,sizeof pe32 
		invoke Process32First,hSnapshot,addr pe32 
@@:
		test	eax,eax
		jz @false
		mov eax,processid
		cmp pe32.th32ProcessID,eax
		jz @f
		invoke Process32Next,hSnapshot,addr pe32 
		jmp	@b
@@:
		invoke lstrcpy,addr windowfile,addr pe32.szExeFile
		invoke PathStripPath,eax
		invoke CharLower,eax
		invoke lstrlen,eax
		.if	eax > fnamelen2
			mov	fnamelen2,eax
		.endif
		jmp	@f
@false:
		mov	byte ptr windowfile,'?'
		mov	byte ptr windowfile+1,0
@@:
		invoke CloseHandle,hSnapshot
		invoke GetClassName,hwnd,addr winclass,MAX_PATH
		invoke SendMessageTimeout,hwnd,WM_GETTEXT,MAX_PATH,addr winname,SMTO_ABORTIFHUNG,20,0
		test eax,eax
		jnz @f
;		invoke lstrcpy,addr winname,addr tout
		invoke GetWindowText,hwnd,addr winname,MAX_PATH
@@:
		invoke lstrlen,addr winname
		.if	eax > namelen2
			mov	namelen2,eax
		.endif
		inc	count
		invoke wsprintf,addr buf,addr frmt,count,hwnd,addr status,wdth,hght,\
				lft,tp,threadid,processid,addr windowfile,addr winname,addr winclass
		invoke lstrcat,addr bigbuf,addr buf
		xor eax,eax
		inc eax
	 	ret
EnWinProc endp

;###########################################################################################

start:
		xor	eax,eax
		mov	hMon,eax
		mov	status,eax
		invoke lstrlen,addr filename
		mov	fnamelen,eax
		invoke CreateFile,addr filename,GENERIC_READ or GENERIC_WRITE,\
				FILE_SHARE_READ,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
		cmp eax,INVALID_HANDLE_VALUE
		jz @exit
		mov	count,eax
		invoke WriteFile,eax,addr filename,fnamelen,addr fnamelen,0
		mov tp,eax
		invoke CloseHandle,count
		cmp tp,0
		jz @exit
		invoke ShellExecute,0,0,addr filename,0,0,3
		cmp	eax,33
		jb @exit
@@:
		invoke GetDesktopWindow
		invoke EnumChildWindows,eax,addr EnChProc,0
		cmp	hMon,0
		jz	@b
		xor	eax,eax
		mov	dword ptr bigbuf2,eax
		mov	namelen,eax
		mov	fnamelen,eax
@@:
;		invoke Sleep,10
		xor	eax,eax
		mov	namelen2,eax
		mov	fnamelen2,eax
		mov	count,eax
		mov hwin,eax

		invoke wsprintf,addr frmt,addr format0,addr format,addr p_,fnamelen,addr s_,addr p_,namelen,addr s_,addr p_,addr s_
		sub fnamelen,6
		sub namelen,1
		invoke wsprintf,addr buf,addr caption,0,0,addr p_,fnamelen,addr s_,addr p_,namelen,addr s_
		invoke wsprintf,addr bigbuf,addr buf,0,0
@n:
		invoke IsWindow,hMon
		test eax,eax
		jz @f
		invoke FindWindowEx,HWND_MESSAGE,hwin,0,0
		test eax,eax
		jz @q
		mov hwin,eax
		invoke EnWinProc,hwin,0
		jmp @n
@q:
		mov	eax,namelen2
		mov	namelen,eax
		mov	eax,fnamelen2
		mov	fnamelen,eax
		invoke IsWindow,hMon
		test eax,eax
		jz	@f
		invoke lstrcmp,addr bigbuf2,addr bigbuf
		test eax,eax
		jz @b
		invoke lstrcpy,addr bigbuf2,addr bigbuf
		invoke SendMessageTimeout,hMon,WM_SETTEXT,0,eax,SMTO_ABORTIFHUNG,20,0
		jmp	@b
@@:
		invoke DeleteFile,addr filename
@exit:
		invoke ExitProcess,eax
end start
